/***************************************************************************
*   Copyright (C) 2004 by Kita Developers                                 *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITABBSVIEW_H
#define KITABBSVIEW_H

#include <QtCore/QList>
#include <QtGui/QWidget>

class QHBoxLayout;
class QSpacerItem;
class QTreeWidget;
class QTreeWidgetItem;
class QVBoxLayout;

class KAction;
class KComboBox;
class KUrl;

namespace Kita
{
    class Board;
    class Category;
    class ListViewItem;

    /**
     *
     * @author Hideki Ikemoto <ikemo@users.sourceforge.jp>
     **/
    class BBSView : public QWidget
    {
        Q_OBJECT
        ListViewItem* m_favorites;

        QList<Category> getCategoryList(const QString& html) const;

        void saveOpened();
        KComboBox* searchCombo;
        QTreeWidget* m_boardList;
        void contextMenuEvent(QContextMenuEvent* e);

    protected:
        QVBoxLayout* bbsViewBaseLayout;
        QHBoxLayout* layout10;
        QSpacerItem* spacer2;

    private slots:
        void loadBoard(QTreeWidgetItem* item);
        void refreshFavoriteBoards();
        void filter(const QString& str);
        void slotMenuOpenWithBrowser();

    public:
        explicit BBSView(QWidget *parent);
        ~BBSView();

        void loadOpened();

    public slots:
        void updateBoardList();
        void showBoardList();
        void setFont(const QFont& font);
        virtual void setFocus();

    private:
        void loadExtBoard();
        bool downloadBoardList();
        void mousePressEvent(QMouseEvent *e);
        BBSView(const BBSView&);
        BBSView& operator=(const BBSView&);

        KAction* m_openWithBrowserAct;
        KAction* m_copyUrlAct;
        KAction* m_copyTitleAndUrlAct;
        KAction* m_removeFromFavoritesAct;
        KAction* m_addToFavoritesAct;
    };
}

#endif
