/***************************************************************************
*   Copyright (C) 2004 by Kita Developers                                 *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITABOARDTABWIDGET_H
#define KITABOARDTABWIDGET_H

#include "ktabbar.h"
#include "kitaui/tabwidgetbase.h"

class KAction;

namespace Kita {

    class BoardView;

    /**
     * @author Hideki Ikemoto
     */
    class BoardTabWidget : public TabWidgetBase
    {
        Q_OBJECT

        public:
            explicit BoardTabWidget(QWidget* parent = 0);
            ~BoardTabWidget();

            void updateBoardView(const KUrl& datUrl);

        public slots:
            void loadBoard(const KUrl&);

        private:
            BoardView* createView(QString label);
            BoardView* findView(const KUrl& boardUrl);
            BoardView* isSubjectView(QWidget* w);

        protected:
            virtual void deleteWidget(QWidget* w);


        /* tab actions */

        private:
            void setupActions();

        public slots:
            void slotReloadButton();
            void slotFocusSearchCombo();
            void slotShowOldLogs(int idx = -1);
    };

/*--------------------------------------------------*/

    class SubjectTabBar : public KTabBar
    {
        Q_OBJECT

        public:
            explicit SubjectTabBar(QWidget* parent = 0);
            ~SubjectTabBar();

        public slots:
            virtual void showPopupMenu(int idx, const QPoint& global);

        private:
            KAction* m_closeAct;
            KAction* m_closeOtherAct;
            KAction* m_closeRightAct;
            KAction* m_closeLeftAct;
            KAction* m_showOldLogsAct;
            KAction* m_openBrowserAct;
            KAction* m_copyTitleAct;
    };
}

#endif
