/***************************************************************************
 *   Copyright (C) 2003 by Hideki Ikemoto                                  *
 *   ikemo@users.sourceforge.jp                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "htmlview.h"

#include <khtml_part.h>

using namespace Kita;

HTMLView::HTMLView(KHTMLPart* part, QWidget *parent) : KHTMLView(part, parent)
{}

HTMLView::~HTMLView()
{}

void HTMLView::leaveEvent(QEvent*)
{
    emit leave();
}

/* protected */
void HTMLView::keyPressEvent(QKeyEvent* e)
{
    if (e->key() == Qt::Key_Space || e->key() == Qt::Key_PageDown
            || e->key() == Qt::Key_Down || e->key() == Qt::Key_End) {
        if (emitPushDown()) return ;
    }

    KHTMLView::keyPressEvent(e);
}

/* protected */
void HTMLView::wheelEvent(QWheelEvent * e)
{
    if (e->delta() < 0) { // scroll down
        if (emitPushDown()) return ;
    }

    KHTMLView::wheelEvent(e);
}

/* private */
bool HTMLView::emitPushDown()
{
    int y = contentsY();

    if (y >= contentsHeight() - visibleHeight()) {
        emit pushDown(); // to HTMLPart in order to call slotClickTugi100
        return true;
    }

    return false;
}
