/***************************************************************************
*   Copyright (C) 2004 by Kita Developers                                 *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITAACCOUNT_H
#define KITAACCOUNT_H

#include <QtCore/QByteArray>
#include <QtCore/QEventLoop>
#include <QtCore/QObject>

#include <kdemacros.h>

namespace KIO
{
    class Job;
}

namespace Kita
{

    /**
    @author Hideki Ikemoto
    */
    class KDE_EXPORT Account : public QObject
    {
        Q_OBJECT
        static Account* instance;

        KIO::Job* m_job;
        QByteArray m_data;
        QString m_sessionID;
        bool m_isLogged;
        QEventLoop m_eventLoop;

        Account();
        ~Account();
        void enter_loop();
        bool loginInternal(const QString& userID, const QString& password);
        static Account* getInstance();
    private slots:
        void slotReceiveData(KIO::Job* job, const QByteArray& data);
        void slotResult(KIO::Job* job);
    private:
        Account(const Account&);
        Account& operator=(const Account&);
    public:
        static const QString& getSessionId() { return getInstance() ->m_sessionID; }
        static bool isLogged() { return getInstance() ->m_isLogged; }
        static bool login(const QString& userID, const QString& password);
    };

}

#endif
