/***************************************************************************
 *   Copyright (C) 2006 by Kita Developers                                 *
 *   ikemo@users.sourceforge.jp                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef BBS_H
#define BBS_H

#include <kdemacros.h>

class QTextCodec;

namespace Kita {
    class PostData;

    class KDE_EXPORT Bbs {
        public:
            Bbs();
            virtual ~Bbs() { }
            virtual QString buildPostStr(const PostData& data) = 0;

            QString datToUnicode(const QByteArray& ba) const;
            QByteArray datFromUnicode(const QString& str) const;

            QString postToUnicode(const QByteArray& ba) const;
            QByteArray postFromUnicode(const QString& str) const;
        protected:
            static QString encodeString(const QString &str, int encoding_hint);

            QTextCodec* m_readCodec;
            QTextCodec* m_writeCodec;

        private:
            static QString encode(const QString& segment, int encoding_offset,
                    int encoding_hint, bool isRawURI = false);
    };
}

#endif

