/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@wakaba.jp                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITACACHE_H
#define KITACACHE_H

#include <QtCore/QString>

#include <kurl.h>

namespace Kita
{

    /**
    @author Hideki Ikemoto
    */
    class KDE_EXPORT Cache
    {
        public:
            Cache(const KUrl& url);

            QString serverDir() const;
            QString boardDir() const;

            QString getPath() const;
            QString getIndexPath() const;
            QString getSettingPath() const;
            QString getBBSHistoryPath() const;
            QString getSubjectPath() const;
            QString getDirPath() const;

            static QString baseDir();

        private:
            KUrl m_url;
    };
}

#endif
