/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@wakaba.jp                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITAFAVORITEBOARDS_H
#define KITAFAVORITEBOARDS_H

#include <QtCore/QList>
#include <QtCore/QObject>

#include <kurl.h>

class QDomNode;

namespace Kita
{
    /**
    @author Hideki Ikemoto
    */
    class KDE_EXPORT FavoriteBoards : public QObject
    {

        Q_OBJECT

        static FavoriteBoards* instance;
        QList<KUrl> m_list;
        FavoriteBoards();
        ~FavoriteBoards();

        static void processChildNode(QDomNode& node);
    private:
        void notifyChange();
    public:
        static FavoriteBoards* getInstance();
        static void append(KUrl& url);
        static void remove(KUrl& url);
        static const QList<KUrl>& boards();
        static bool readFromXML(QString& xml);
        static QString toXML();
        static void replace(const QString& fromUrl, const QString& toUrl);
    signals:
        void changed();
    };
}

#endif
