/***************************************************************************
 *   Copyright (C) 2004 by Kita Developers                                 *
 *   ikemo@users.sourceforge.jp                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef FAVORITETHREADS_H
#define FAVORITETHREADS_H

#include <QtCore/QList>
#include <QtCore/QString>

#include <kdemacros.h>

class QDomNode;

/**
 *@author Hideki Ikemoto
 */
class FavoriteThreadItem
{
public:
    QString m_datUrl;
    FavoriteThreadItem();
    FavoriteThreadItem(const QString& datUrl) { m_datUrl = datUrl; }
    ~FavoriteThreadItem();

    bool operator==(const FavoriteThreadItem& item) const;
};

class KDE_EXPORT FavoriteThreads
{
    static FavoriteThreads* instance;
    QList<FavoriteThreadItem> m_threadList;

    FavoriteThreads();
    ~FavoriteThreads();

    const QList<FavoriteThreadItem> threadList() const;
    static void processThreadNode(QDomNode& node);

public:
    static FavoriteThreads* getInstance();

    void insert(const QString& datUrl);
    void remove(const QString& datUrl);
    bool contains(const QString& datUrl);
    const QString toXML() const;
    static bool readFromXML(const QString& xml);
    static void replace(const QString& fromUrl, const QString& toUrl);
    static QString getDatUrl(int i);
    static int count() { return getInstance() ->m_threadList.count(); }
};

#endif
