/***************************************************************************
 *   Copyright (C) 2006 by Kita Developers                                 *
 *   ikemo@users.sourceforge.jp                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "k2ch.h"

#include <QtCore/QTextCodec>

#include "kita_misc.h"
#include "postdata.h"

using namespace Kita;

QString K2ch::buildPostStr(const PostData& data)
{
    QString ret;

    int mib = m_writeCodec->mibEnum();

    ret += "submit=%8f%91%82%ab%8d%9e%82%de";  // kakikomu

    // from, mail, message, bbs
    ret += "&FROM=" + encodeString(data.name(), mib);
    ret += "&mail=" + encodeString(data.mail(), mib);
    ret += "&MESSAGE=" + encodeString(data.body(), mib);
    ret += "&bbs=" + data.boardId();
    ret += "&tepo=don";

    // key
    ret += "&key=" + data.threadId();

    // time
    ret += "&time=" + QString::number(data.serverTime());

    // login
    if (!data.sessionId().isEmpty()) {
        ret += "&sid=" + data.sessionId();
    }

    return ret;
}
