/***************************************************************************
*   Copyright (C) 2004 by Kita Developers                                 *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITAKITA_MISC_H
#define KITAKITA_MISC_H

#include <QtCore/QString>

#include <kdemacros.h>

class QDateTime;
class QFont;

class KUrl;

struct RESDAT;


/* URL conversion mode. see also Kita::convertURL()  */
enum{
    URLMODE_DAT,
    URLMODE_THREAD
};

namespace Kita
{
    /**
     * @author Hideki Ikemoto
     */
    /*------------------------------*/
    /* conversion of URL */
    KDE_EXPORT KUrl getDatUrl(const KUrl& url , QString& refstr);
    KDE_EXPORT KUrl getDatUrl(const KUrl& url);

    QString getThreadUrl(const KUrl& url, QString& refstr);
    KDE_EXPORT QString getThreadUrl(const KUrl& url);
    KDE_EXPORT QString getWriteUrl(const KUrl& datUrl);

    QString convertUrl(int mode, const KUrl& url , QString& refstr);

    QString datToOfflaw(const KUrl& datUrl);


    /*------------------------------*/
    /* utilities */
    KDE_EXPORT uint datToSince(const KUrl& datUrl);
    KDE_EXPORT int stringToPositiveNum(const QChar *cdat, const unsigned int length);
    KDE_EXPORT QString getCategory(const QString& line);
    KDE_EXPORT bool isBoardUrl(const QString& url);
    KDE_EXPORT QString fontToString(const QFont& font);

    /*------------------------------*/
    /* internal parsing functions */
    KDE_EXPORT QStringList parseSearchQuery(const QString& input);


    /* for MACHI BBS */
    void InitParseMachiBBS();
    QString ParseMachiBBSOneLine(const QString& inputLine, int& nextNum);

    /* for JBBS */
    QString ParseJBBSOneLine(const QString& line, int& nextNum);


    /* for Flash CGI/Mini Thread */
    QString ParseFlashCGIOneLine(const QString& line);
}

#endif
