/***************************************************************************
 *   Copyright (C) 2006 by Kita Developers                                 *
 *   ikemo@users.sourceforge.jp                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "postdata.h"

#include "account.h"
#include "datmanager.h"

using namespace Kita;

PostData::PostData(const KUrl& datUrl, const QString& name, const QString& mail,
        const QString& body, const QString& boardId)
{
    m_datUrl = datUrl;
    m_name = name;
    m_mail = mail;
    m_body = body;
    m_boardId = boardId;
    DatManager datManager(m_datUrl);
    m_threadId = datManager.threadId();
    m_serverTime = datManager.getServerTime();
    // login
    if (datManager.is2chThread() && Account::isLogged()) {
        m_sessionId = KUrl::toPercentEncoding(Account::getSessionId());
    } 
}

const QString& PostData::name() const
{
    return m_name;
}

const QString& PostData::mail() const
{
    return m_mail;
}

const QString& PostData::body() const
{
    return m_body;
}

const QString& PostData::boardId() const
{
    return m_boardId;
}

const QString& PostData::threadId() const
{
    return m_threadId;
}

int PostData::serverTime() const
{
    return m_serverTime;
}

const QString& PostData::sessionId() const
{
    return m_sessionId;
}
