/***************************************************************************
 *   Copyright (C) 2006 by Kita Developers                                 *
 *   ikemo@users.sourceforge.jp                                            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef POSTDATA_H
#define POSTDATA_H

#include <QtCore/QString>

#include <kurl.h>

namespace Kita {
    class KDE_EXPORT PostData {
        public:
            PostData(const KUrl& datUrl, const QString& name,
                    const QString& mail, const QString& body,
                    const QString& boardId);

            const QString& name() const;
            const QString& mail() const;
            const QString& body() const;
            const QString& boardId() const;
            const QString& threadId() const;
            int serverTime() const;
            const QString& sessionId() const;
        private:
            KUrl m_datUrl;
            QString m_name;
            QString m_mail;
            QString m_body;
            QString m_boardId;
            QString m_threadId;
            int m_serverTime;
            QString m_sessionId;
    };
}

#endif
