/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#include "threadinfo.h"

#include <QtCore/QDataStream>
#include <QtCore/QMap>

using namespace Kita;

ThreadInfo* ThreadInfo::instance = 0;

ThreadInfo::ThreadInfo() : m_readDict()
{}

ThreadInfo::~ThreadInfo()
{}

ThreadInfo* ThreadInfo::getInstance()
{
    if (instance == 0) {
        instance = new ThreadInfo();
    }
    return instance;
}

int ThreadInfo::readNum(const QString& url)
{
    ThreadInfo * instance = ThreadInfo::getInstance();
    if (instance->m_readDict.contains(url)) {
        return instance->m_readDict[ url ];
    } else {
        return 0;
    }
}

void ThreadInfo::setReadNum(const QString& url, int num)
{
    ThreadInfo * instance = ThreadInfo::getInstance();
    instance->m_readDict.insert(url, num);
}

void ThreadInfo::replace(const QString& fromUrl, const QString& toUrl)
{
    QMap<QString, int>::Iterator it;
    ThreadInfo* instance = ThreadInfo::getInstance();
    if (instance == 0) return ;

    for (it = instance->m_readDict.begin(); it != instance->m_readDict.end(); ++it) {
        QString url = it.key();
        int num = it.value();
        if (url.indexOf(fromUrl) == 0) {
            url = url.replace(0, fromUrl.length(), toUrl);
            instance->m_readDict.erase(it);
            instance->m_readDict.insert(url, num);
            it = instance->m_readDict.begin(); // TODO もっと早い方法は?
        }
    }
}

void ThreadInfo::removeThreadInfo(const QString& url)
{
    ThreadInfo * instance = ThreadInfo::getInstance();
    instance->m_readDict.remove(url);
}
namespace Kita {
    QDataStream& operator<<(QDataStream& s, ThreadInfo& c)
    {
        s << c.m_readDict;
        return s;
    }

    QDataStream& operator>>(QDataStream& s, ThreadInfo& c)
    {
        s >> c.m_readDict;
        return s;
    }
}
