/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@wakaba.jp                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#include "aboneprefpage.h"

#include "libkita/abone.h"

using namespace Kita;

AbonePrefPage::AbonePrefPage(QWidget *parent)
: AbstractPrefPage(parent)
{
    setupUi(this);
    load();
    connect(idAboneText, SIGNAL(textChanged()), SIGNAL(changed()));
    connect(nameAboneText, SIGNAL(textChanged()), SIGNAL(changed()));
    connect(wordAboneText, SIGNAL(textChanged()), SIGNAL(changed()));
}

void AbonePrefPage::apply()
{
    QString idText = idAboneText->toPlainText();
    QStringList idList = idText.split('\n', QString::SkipEmptyParts);
    AboneConfig::setAboneIDList(idList);

    QString nameText = nameAboneText->toPlainText();
    QStringList nameList = nameText.split('\n', QString::SkipEmptyParts);
    AboneConfig::setAboneNameList(nameList);

    QString wordText = wordAboneText->toPlainText();
    QStringList wordList = wordText.split('\n', QString::SkipEmptyParts);
    AboneConfig::setAboneWordList(wordList);
}

void AbonePrefPage::load()
{
    idAboneText->setText(AboneConfig::aboneIDList().join("\n"));
    nameAboneText->setText(AboneConfig::aboneNameList().join("\n"));
    wordAboneText->setText(AboneConfig::aboneWordList().join("\n"));
}

void AbonePrefPage::reset()
{
    AboneConfig::self()->useDefaults(true);
    load();
    AboneConfig::self()->useDefaults(false);
}
