/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#include "asciiartprefpage.h"

#include "libkita/asciiart.h"
#include "libkita/globalconfig.h"

using namespace Kita;

AsciiArtPrefPage::AsciiArtPrefPage(QWidget* parent) : AbstractPrefPage(parent)
{
    setupUi(this);
    load();
    connect(asciiArtText, SIGNAL(textChanged()), SIGNAL(changed()));
}

void AsciiArtPrefPage::apply()
{
    QString text = asciiArtText->toPlainText();
    QStringList list = text.split('\n');

    AsciiArtConfig::setAsciiArtList(list);
}

void AsciiArtPrefPage::load()
{
    asciiArtText->setText(AsciiArtConfig::asciiArtList().join("\n"));
    asciiArtText->setFont(GlobalConfig::threadFont());
}

void AsciiArtPrefPage::reset()
{
    AsciiArtConfig::self()->useDefaults(true);
    load();
    AsciiArtConfig::self()->useDefaults(false);
}
