/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#ifndef KITAPREFERENCES_H
#define KITAPREFERENCES_H

#include <QtCore/QList>

#include <kpagedialog.h>

namespace Kita
{
    class AbstractPrefPage;

    class KDE_EXPORT Preferences : public KPageDialog
    {
        Q_OBJECT

    public:
        Preferences(QWidget* parent);
        void load();

    private:
        QList<AbstractPrefPage*> m_pageList;
        void apply();
        void reset();
        Preferences(const Preferences&);
        Preferences& operator=(const Preferences&);
 
    private slots:
        virtual void slotButtonClicked(int button);
        void slotChanged();

    signals:
        void fontChanged(const QFont&);
    };
}

#endif // KITAPREFERENCES_H
