/***************************************************************************
*   Copyright (C) 2007 by Kita Developers                                 *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITARESPOPUP_H
#define KITARESPOPUP_H

#include <QtGui/QFrame>

#include <kurl.h>

class KHTMLView;


namespace Kita
{
    class HTMLPart;

    class ResPopup : public QFrame
    {
        Q_OBJECT

        HTMLPart* m_htmlPart;
        KUrl m_url;


    public:
        ResPopup(KHTMLView* view, const KUrl& datUrl);
        ~ResPopup();
        void setText(const QString& str);
        void adjustSize();
        void adjustPos(const QPoint& point);
        void moveMouseAbove();

    private:
        void showImage(const KUrl& url);
        ResPopup(const ResPopup&);
        ResPopup& operator=(const ResPopup&);

    signals:
        void hideChildPopup();
    };
}

#endif
