/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@wakaba.jp                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITATHREADLISTHEADERVIEW_H
#define KITATHREADLISTHEADERVIEW_H

#include <QtGui/QHeaderView>

class KAction;

struct ColumnAttribute
{
    const char* const labelName; /// for header's label
    const char* const itemName;  /// for header's popupItem
    QString keyName;   /// for KConfig's key
    bool showDefault;  /// default setting.
};

namespace Kita
{
    class ThreadListHeaderView : public QHeaderView
    {
        Q_OBJECT

    public:
        explicit ThreadListHeaderView(QWidget* parent = 0);
        static const ColumnAttribute attribute[];

    private:
        void contextMenuEvent(QContextMenuEvent *event);

        KAction* m_autoResizeAct;
    };
}

#endif
