/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto                                  *
*   ikemo@wakaba.jp                                                       *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITATHREADLISTVIEW_H
#define KITATHREADLISTVIEW_H

#include <QtCore/QList>

#include "ui_threadlistviewbase.h"

class KAction;

namespace Kita
{
    class Thread;
    /**
    @author Hideki Ikemoto
    */
    class ThreadListView : public QWidget, public Ui::ThreadListViewBase
    {
        Q_OBJECT

    public:
        explicit ThreadListView(QWidget* parent = 0);
        virtual ~ThreadListView();

    protected:
        QStringList m_prevquery;
        unsigned m_nextHitIndex;
        QList<QTableWidgetItem *> m_hitList;
        KAction* m_deleteLogAct;

        void insertSearchCombo();
        void searchNext(const QStringList& input);
        void searchNew(const QStringList& query);
        void clearSearch();
        void hideColumn(int col);
        void showColumn(int col);
        void contextMenuEvent(QContextMenuEvent* event);
        virtual void deleteLog(const KUrl& url);

    protected slots:
        void slotHideButton(bool on);
        void slotItemClicked(QTableWidgetItem*);

    private slots:
        void slotSearchButton();

    private:
        KAction* m_openWithBrowserAct;
        KAction* m_copyUrlAct;
        KAction* m_copyTitleAndUrlAct;
        KAction* m_favoritesAct;
        KAction* m_propertyAct;
    };
}

#endif
