/***************************************************************************
*   Copyright (C) 2004 by Kita Developers                                 *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/

#include "threadlistviewitem.h"

using namespace Kita;

ThreadListViewItem::ThreadListViewItem(int column)
    : QTableWidgetItem(Qt::ItemIsSelectable), m_column(column)
{}

/* public */ /* virtual */
bool ThreadListViewItem::operator<(const QTableWidgetItem& other) const
{
    QString thisText = text();
    QString otherText = other.text();
    switch (m_column) {
    case ColumnResNum:
    case ColumnReadNum:
    case ColumnUnread:
        return thisText.toInt() > otherText.toInt();
    case ColumnId:
        return thisText.toInt() > otherText.toInt();
    case ColumnMark:
        return data(Qt::UserRole).toInt() > other.data(Qt::UserRole).toInt();
    case ColumnSince:
        return QString::localeAwareCompare(thisText, otherText) > 0;
    case ColumnSpeed:
        return thisText.toDouble() * 1000 > otherText.toDouble() * 1000;
    default:
        return QString::localeAwareCompare(thisText, otherText) > 0;
    }
}
