/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto, 2004 by 421                     *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITATHREADTABWIDGET_H
#define KITATHREADTABWIDGET_H

#include "kitaui/tabwidgetbase.h"

namespace Kita {
    class ThreadView;

    class ThreadTabWidget : public TabWidgetBase
    {
        Q_OBJECT

    public:
        explicit ThreadTabWidget(QWidget* parent = 0);
        ~ThreadTabWidget();

    public slots:
        void slotShowMainThread(const KUrl& datUrl);
        void slotCloseThreadTab(const KUrl& url);
        void slotUpdateThreadTab(const KUrl& url);

    private:
        ThreadView* createView(const QString& label);
        ThreadView* findMainView(const KUrl& url);
        ThreadView* isThreadView(QWidget* w);

    private slots:
        void slotFontChanged();


    protected:
        virtual void deleteWidget(QWidget* w);


        /*------------------------------------*/
        /* ThreadView actions */

    private:
        void setupActions();
        void contextMenuEvent(QContextMenuEvent* e);

        QList<QAction*> m_actionList;

    public slots:
        void slotCopyText();
        void slotFocusSearchCombo();
        void slotSearchNext();
        void slotSearchPrev();
        void slotGobackAnchor();
        void slotGotoHeader();
        void slotGotoFooter();
        void slotReloadButton();
        void slotStopLoading();
        void slotDeleteButtonClicked();
    };
}

#endif
