/***************************************************************************
*   Copyright (C) 2003 by Hideki Ikemoto, 2004 by 421                     *
*   ikemo@users.sourceforge.jp                                            *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
***************************************************************************/
#ifndef KITAWRITETABWIDGET_H
#define KITAWRITETABWIDGET_H

#include "kitaui/tabwidgetbase.h"

namespace Kita {
    class WriteView;

    class WriteTabWidget : public TabWidgetBase
    {
        Q_OBJECT

    public:
        explicit WriteTabWidget(QWidget* parent = 0);
        ~WriteTabWidget();
        void slotShowWriteView(const KUrl& url, const QString& resStr);

    private:
        void openWriteView(const KUrl& url, const QString& resStr = QString(),
                const QString& subject = QString());
        WriteView* findWriteView(const KUrl& url);
        WriteView* isWriteView(QWidget* w);

    public:
        void slotChangeWriteTab(const KUrl& url);

    protected:
        virtual void deleteWidget(QWidget* w);


        /*------------------------------------*/
        /* WriteTabWidget actions */

    private:
        void setupActions();

    public slots:
        void slotQuoteClipboard();
    };
}

#endif
